# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from abb_rapid_msgs/RobJoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class RobJoint(genpy.Message):
  _md5sum = "24a88117c4b385974e50d44f6663eb2a"
  _type = "abb_rapid_msgs/RobJoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#-------------------------------------------------------------------------------
# Description:
#   The purpose of this message definition, is to represent the
#   RAPID data type "robjoint" (joint position of robot axes).
#
# Note:
#   Please see the "Technical reference manual - RAPID Instructions,
#   Functions and Data types" for more details.
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Message fields
#-------------------------------------------------------------------------------
# The position of robot axis 1-6 in degrees from the calibration position.
float32 rax_1
float32 rax_2
float32 rax_3
float32 rax_4
float32 rax_5
float32 rax_6
"""
  __slots__ = ['rax_1','rax_2','rax_3','rax_4','rax_5','rax_6']
  _slot_types = ['float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       rax_1,rax_2,rax_3,rax_4,rax_5,rax_6

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RobJoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.rax_1 is None:
        self.rax_1 = 0.
      if self.rax_2 is None:
        self.rax_2 = 0.
      if self.rax_3 is None:
        self.rax_3 = 0.
      if self.rax_4 is None:
        self.rax_4 = 0.
      if self.rax_5 is None:
        self.rax_5 = 0.
      if self.rax_6 is None:
        self.rax_6 = 0.
    else:
      self.rax_1 = 0.
      self.rax_2 = 0.
      self.rax_3 = 0.
      self.rax_4 = 0.
      self.rax_5 = 0.
      self.rax_6 = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_6f().pack(_x.rax_1, _x.rax_2, _x.rax_3, _x.rax_4, _x.rax_5, _x.rax_6))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.rax_1, _x.rax_2, _x.rax_3, _x.rax_4, _x.rax_5, _x.rax_6,) = _get_struct_6f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_6f().pack(_x.rax_1, _x.rax_2, _x.rax_3, _x.rax_4, _x.rax_5, _x.rax_6))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 24
      (_x.rax_1, _x.rax_2, _x.rax_3, _x.rax_4, _x.rax_5, _x.rax_6,) = _get_struct_6f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_6f = None
def _get_struct_6f():
    global _struct_6f
    if _struct_6f is None:
        _struct_6f = struct.Struct("<6f")
    return _struct_6f
